#include "vcl/dstring.h"
#include <dir.h>

class TM2000
{
 private:
  char TempFile[MAXPATH];
  int FVideoMode;
  int FP2000Model;
  int FPrinterType;
  int FVerbose;
  int FSync;
  int FBoot;
  int FJoystick;
  int FRAMSize;
  int FUPeriod;
  int FIFreq;
  int FCPUSpeed;
  int FSoundDevice;
  int FVolume;
  AnsiString FM2000Path;
  AnsiString FCassetteImage;
  AnsiString FMonitorROM;
  AnsiString FCartridgeROM;
  AnsiString FFontImage;
  AnsiString FPrinterLog;
  AnsiString FUserOptions;
  AnsiString FReadMeFile;
 public:
  TM2000();
  ~TM2000();
  int Execute(void);
  void LoadFromFile (AnsiString&);
  void SaveToFile (AnsiString&);
  void GetEmulatorOptions (AnsiString&);
  void SetVideoMode(int);
  void SetP2000Model(int);
  void SetPrinterType(int);
  void SetVerbose(int);
  void SetSync(int);
  void SetBoot(int);
  void SetJoystick(int);
  void SetRAMSize(int);
  void SetUPeriod(int);
  void SetIFreq(int);
  void SetCPUSpeed(int);
  void SetSoundDevice(int);
  void SetVolume(int);
  void SetM2000Path(AnsiString&);
  void SetCassetteImage(AnsiString&);
  void SetMonitorROM(AnsiString&);
  void SetCartridgeROM(AnsiString&);
  void SetFontImage(AnsiString&);
  void SetPrinterLog(AnsiString&);
  void SetUserOptions(AnsiString&);
  __property int VideoMode = { read=FVideoMode,write=SetVideoMode };
  __property int P2000Model = { read=FP2000Model,write=SetP2000Model };
  __property int PrinterType = { read=FPrinterType,write=SetPrinterType };
  __property int Verbose = { read=FVerbose,write=SetVerbose };
  __property int Sync = { read=FSync,write=SetSync };
  __property int Boot = { read=FBoot,write=SetBoot };
  __property int Joystick = { read=FJoystick,write=SetJoystick };
  __property int RAMSize = { read=FRAMSize,write=SetRAMSize };
  __property int UPeriod = { read=FUPeriod,write=SetUPeriod };
  __property int IFreq = { read=FIFreq,write=SetIFreq };
  __property int CPUSpeed = { read=FCPUSpeed,write=SetCPUSpeed };
  __property int SoundDevice = { read=FSoundDevice,write=SetSoundDevice };
  __property int Volume = { read=FVolume,write=SetVolume };
  __property AnsiString M2000Path = { read=FM2000Path,write=SetM2000Path };
  __property AnsiString CassetteImage = { read=FCassetteImage,write=SetCassetteImage };
  __property AnsiString MonitorROM = { read=FMonitorROM,write=SetMonitorROM };
  __property AnsiString CartridgeROM = { read=FCartridgeROM,write=SetCartridgeROM };
  __property AnsiString FontImage = { read=FFontImage,write=SetFontImage };
  __property AnsiString PrinterLog = { read=FPrinterLog,write=SetPrinterLog };
  __property AnsiString UserOptions = { read=FUserOptions,write=SetUserOptions };
  __property AnsiString ReadMeFile = { read=FReadMeFile };
};

