//---------------------------------------------------------------------------
#ifndef M2000BuilderMainH
#define M2000BuilderMainH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Tabnotbk.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Mask.hpp>
#include <vcl\Buttons.hpp>
#include "M2000.h"
#include <vcl\Dialogs.hpp>
#include <stdio.h>
//---------------------------------------------------------------------------
class TM2000BuilderMainForm : public TForm
{
__published:	// IDE-managed Components
	TTabbedNotebook *MainTabbedNotebook;
	TPanel *M2000PathPanel;
	TLabel *Label1;
	TPanel *CassettePanel;
	TLabel *Label2;
	TPanel *MonitorPanel;
	TLabel *Label3;
	TPanel *CartridgePanel;
	TLabel *Label4;
	TRadioGroup *VideoModeRadioGroup;
	TPanel *FontPanel;
	TLabel *Label7;
	TBitBtn *M2000PathButton;
	TBitBtn *CassetteButton;
	TBitBtn *MonitorButton;
	TBitBtn *CartridgeButton;
	TBitBtn *FontButton;
	TRadioGroup *P2000ModelRadioGroup;
	TRadioGroup *SoundRadioGroup;
	TPanel *VolumePanel;
	TLabel *Label8;
	TRadioGroup *PrinterTypeRadioGroup;
	TUpDown *VolumeUpDown;
	TBitBtn *LaunchButton;
	TBitBtn *CloseButton;
	TBitBtn *AboutButton;
	TPanel *UPeriodPanel;
	TLabel *Label5;
	TUpDown *UPeriodUpDown;
	TPanel *RAMSizePanel;
	TLabel *Label6;
	TPanel *CPUSpeedPanel;
	TLabel *Label10;
	TPanel *IFreqPanel;
	TLabel *Label12;
	TPanel *PrinterLogPanel;
	TLabel *Label14;
	TBitBtn *PrinterLogButton;
	TLabel *Label16;
	TLabel *Label15;
	TMemo *BuilderReadMeMemo;
	TMemo *M2000ReadMeMemo;
	TLabel *Label17;
	TLabel *Label18;
	TBitBtn *LaunchBuilderReadMeBitBtn;
	TBitBtn *LaunchM2000ReadMeBitBtn;
	TLabel *Label19;
	TMemo *UserOptionsMemo;
	TMemo *UserOptionsInstructionsMemo;
	TCheckBox *BootCheckBox;
	TCheckBox *SyncCheckBox;
	TCheckBox *VerboseCheckBox;
	TCheckBox *JoystickCheckBox;
	TUpDown *RAMSizeUpDown;
	TUpDown *IFreqUpDown;
	TUpDown *CPUSPeedUpDown;
	TEdit *RAMSizeEdit;
	TEdit *UPeriodEdit;
	TEdit *IFreqEdit;
	TEdit *CPUSpeedEdit;
	TEdit *VolumeEdit;
	TMemo *OptionsMemo;
	TLabel *Label9;
	TEdit *M2000PathEdit;
	TEdit *CassetteEdit;
	TEdit *MonitorEdit;
	TEdit *CartridgeEdit;
	TEdit *FontEdit;
	TEdit *PrinterLogEdit;
	TOpenDialog *OpenDialogue;
	void __fastcall AboutButtonClick(TObject *Sender);

	void __fastcall UPeriodUpDownClick(TObject *Sender, TUDBtnType Button);
	void __fastcall VolumeUpDownClick(TObject *Sender, TUDBtnType Button);
	void __fastcall RAMSizeUpDownClick(TObject *Sender, TUDBtnType Button);
	void __fastcall IFreqUpDownClick(TObject *Sender, TUDBtnType Button);
	void __fastcall CPUSPeedUpDownClick(TObject *Sender, TUDBtnType Button);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall RadioGroupClick(TObject *Sender);
	void __fastcall MainTabbedNotebookChange(TObject *Sender, int NewTab,
	bool &AllowChange);
	void __fastcall CheckBoxClick(TObject *Sender);
	void __fastcall EditExit(TObject *Sender);
	void __fastcall MemoExit(TObject *Sender);
	void __fastcall LaunchButtonClick(TObject *Sender);
	void __fastcall StringEditExit(TObject *Sender);
	void __fastcall LaunchBitBtnClick(TObject *Sender);
	void __fastcall OpenButtonClick(TObject *Sender);
private:	// User declarations
    TM2000 *M2000;
    void SetAllOptions (void);		// initialise all checkboxes, etc.
    void SetEmulatorOptions (void);	// initialise OptionsMemo
    void UpdateAllOptions (void);	// parse newly entered values
	AnsiString ReadMeFile;			// M2000Builder.txt path
    AnsiString IniFile;				// M2000Builder.ini path
public:		// User declarations
	__fastcall TM2000BuilderMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TM2000BuilderMainForm *M2000BuilderMainForm;
//---------------------------------------------------------------------------
#endif
